--
-- 
--
togglekey = "F2"

enabled = false


	function main()
		-- Version check
		local ver = getVersion ().sortable
		local type = string.sub( ver, 7, 7 )
		local build = string.sub( ver, 9, 13 )
		if build < "02888" and type ~= "1" or ver < "1.1.0" then
			outputChatBox( "Resource is not compatible with this client." )
			outputChatBox( "Please get latest 1.1 nightly from nightly.mtasa.com" )
			return
		end

		-- Create water shader
		myWaterShader, tec = dxCreateShader ( "water.fx" )
		
		if not myWaterShader then
			outputChatBox( "Could not create shader. Please use debugscript 3" )
		else
--			outputChatBox( "Using technique " .. tec )

			-- Set textures
			local texture1 = dxCreateTexture ( "images/smallnoise3d.dds" );
			local texture2 = dxCreateTexture ( "images/env3.bmp" );
			dxSetShaderValue ( myWaterShader, "microflakeNMap_Tex", texture1 );
			dxSetShaderValue ( myWaterShader, "showroomMap_Tex", texture2 );

			-- Apply to global txd 13
--			engineApplyShaderToWorldTexture ( myWaterShader, "waterclear256" )

			-- Update water color incase it gets changed by persons unknown
--			waterTimer = setTimer ( checkWaterColor, 1000, 0 )
			
			end
		
		
		-- Create car shader
		myCarShader, tec = dxCreateShader ( "car_paint.fx" )

		if not myCarShader then
			outputChatBox( "Could not create shader. Please use debugscript 3" )
			else
		
		
		--outputChatBox( "Graphic Booster is DISABLED. Press ".. togglekey.. " to toggle it." )

		-- Set textures
		 textureVol = dxCreateTexture ( "images/smallnoise3d.dds" );
		 textureCube = dxCreateTexture ( "images/cube_env256.dds" );
		dxSetShaderValue ( myCarShader, "microflakeNMapVol_Tex", textureVol );
		dxSetShaderValue ( myCarShader, "showroomMapCube_Tex", textureCube );
toggle()
				end
				end
				
	function checkWaterColor ( )
	if myWaterShader then
		local r,g,b,a = getWaterColor()
		dxSetShaderValue ( myWaterShader, "waterColor", r/255, g/255, b/255, a/255 );
	end
end

-- RADAR shader -----


-- No touch, kthxbai
local tiles = { }
local timer
local enabled = false

local ROW_COUNT = 12

function toggleRadar()
	-- Toggle!
	
	
	-- Check whether we enabled it
	if enabled then
	enabled = false
		-- Load all tiles
		handleTileLoading ( )
		
		-- Set a timer to check whether new tiles should be loaded (less resource hungry than doing it on render)
		timer = setTimer ( handleTileLoading, 500, 0 )
	else
	enabled = true
		-- If our timer is still running, kill it with fire
		if isTimer ( timer ) then killTimer ( timer ) end
		
		-- Unload all tiles, so the memory footprint has disappeared magically
		for name, data in pairs ( tiles ) do
			unloadTile ( name )
		end
	end
end
--bindKey("F5","down",toggleCustomTiles)
addCommandHandler ( "rad", toggleRadar )

function handleTileLoading ( )
	-- Get all visible radar textures
	local visibleTileNames = table.merge ( engineGetVisibleTextureNames ( "radar??" ), engineGetVisibleTextureNames ( "radar???" ) )
	
	-- Unload tiles we don't see
	for name, data in pairs ( tiles ) do
		if not table.find ( visibleTileNames, name ) then
			unloadTile ( name )
		end
	end
	
	-- Load tiles we do see
	for index, name in ipairs ( visibleTileNames ) do
		loadTile ( name )
	end
end

function table.merge ( ... )
	local ret = { }
	
	for index, tbl in ipairs ( {...} ) do
		for index, val in ipairs ( tbl ) do
			table.insert ( ret, val )
		end
	end
	
	return ret
end

function table.find ( tbl, val )
	for index, value in ipairs ( tbl ) do
		if value == val then
			return index
		end
	end
	
	return false
end

-------------------------------------------
--
-- Tile loading and unloading functions
--
-------------------------------------------

function loadTile ( name )
	-- Make sure we have a string
	if type ( name ) ~= "string" then
		return false
	end
	
	-- Check whether we already loaded this tile
	if tiles[name] then
		return true
	end
	
	-- Extract the ID
	local id = tonumber ( name:match ( "%d+" ) )
	
	-- If not a valid ID, abort
	if not id then
		return false
	end
	
	-- Calculate row and column
	local row = math.floor ( id / ROW_COUNT )
	local col = id - ( row * ROW_COUNT )
	
	-- Now just calculate start and end positions
	local posX = -3000 + 500 * col
	local posY =  3000 - 500 * row
	
	-- Fetch the filename
	local file = string.format ( "sattelite/sattelite_%d_%d.jpeg", row, col )
	
	-- Now, load that damn file! (Also create a transparent overlay texture)
	local texture = dxCreateTexture ( file )
	
	-- If it failed to load, abort
	if not texture --[[or not overlay]] then
		outputChatBox ( string.format ( "Failed to load texture for %q (%q)", tostring ( name ), tostring ( file ) ) )
		return false
	end
	
	-- Now we just need the shader
	local shader = dxCreateShader ( "data/texreplace.fx" )
	
	-- Abort if failed (don't forget to destroy the texture though!!!)
	if not shader then
		outputChatBox ( "Failed to load shader" )
		destroyElement ( texture )
		return false
	end
	
	-- Now hand the texture to the shader
	dxSetShaderValue ( shader, "gTexture", texture )
	
	-- Now apply this stuff on the tile
	engineApplyShaderToWorldTexture ( shader, name )
	
	-- Store the stuff
	tiles[name] = { shader = shader, texture = texture }
	
	-- Return success
	return true
end

function unloadTile ( name )
	-- Get the tile data
	local tile = tiles[name]
	
	-- If no data is present, we failed
	if not tile then
		return false
	end
	
	-- Destroy the shader and texture elements, if they exist
	if isElement ( tile.shader )  then destroyElement ( tile.shader )  end
	if isElement ( tile.texture ) then destroyElement ( tile.texture ) end
	
	-- Now remove all reference to it
	tiles[name] = nil
	
	-- We succeeded
	return true
end



---_EnD of radarshader
				

	function toggle()
	

	
			if enabled then
			
			--radar
			
			
			
				-- If our timer is still running, kill it with fire
		if isTimer ( timer ) then killTimer ( timer ) end
		
		-- Unload all tiles, so the memory footprint has disappeared magically
		for name, data in pairs ( tiles ) do
			unloadTile ( name )
		end
			
			
			--end radar
			
			
			
			
				killTimer ( waterTimer )
				engineRemoveShaderFromWorldTexture ( myWaterShader, "waterclear256" )
				engineRemoveShaderFromWorldTexture( myCarShader, "vehiclegrunge256" )
				
				enabled = false
				
				outputChatBox( "Graphic Booster is DISABLED. Press ".. togglekey.. " to toggle it." , 255, 255, 0, true )
			else
			
			--radar
			-- Load all tiles
		handleTileLoading ( )
		
		-- Set a timer to check whether new tiles should be loaded (less resource hungry than doing it on render)
		timer = setTimer ( handleTileLoading, 500, 0 )
			--end radar
			
			
			
				waterTimer = setTimer ( checkWaterColor, 1000, 0 )
				
				engineApplyShaderToWorldTexture ( myWaterShader, "waterclear256" )
				engineApplyShaderToWorldTexture ( myCarShader, "vehiclegrunge256" )
				
				outputChatBox( "Graphic Booster is ENABLED. Press ".. togglekey.. " to toggle it.", 255, 255, 0, true )
				enabled = true

				end
				end
	
	
	
	addEventHandler("onClientResourceStart",getResourceRootElement(getThisResource()),main)
	
	
	
	
	bindKey ( togglekey, "down", toggle)
	

